#include <iostream>
#include <boost/lexical_cast.hpp>
using namespace std;
using namespace boost;

int main( int argc, char* argv[] )
{
    if( argc <= 1 )
        return -1;

    try
    {
        int N = lexical_cast<int>( argv[1] );
        for(int i=0; i!=N; ++i)
            cout << "Hello, World." << endl;
    }
    catch( const bad_lexical_cast& e )
    {
        cerr << "Ă" << endl
             << "-- " << e.what()      << endl;
        return -1;
    }

    return 0;
}
