#include <iostream>
#include <boost/numeric/interval.hpp>
using namespace std;
using namespace boost::numeric;

template<typename T,typename P>
  ostream& operator<<( ostream& os, const interval<T,P>& itv )
  {
      return os << "[from " << itv.lower() <<
         " to " << itv.upper() << "]";
  }

int main()
{
    interval<int> x(0, 100);
    interval<int> y(-20, 55);

    // ԂƋԂ̊|Z
    interval<int> z = x*y;
    cout << x << " * " << y << " = " << z << endl;

    // ԂƋԂ̋ʕ
    cout << intersect(x,y) << endl;

    return 0;
}
