#include <iostream>
#include <string>
#include <boost/spirit.hpp>
using namespace std;
using namespace boost::spirit;

// @"ArithCalc"̒`
struct ArithCalc : grammar<ArithCalc>
{
    template<typename ScannerT>
      struct definition
      {
          typedef rule<ScannerT> rule_t;
          rule_t expr, fctr, term;

          definition( const ArithCalc& )
          {
              expr = term >> *('+'>>term | '-'>>term);
              term = fctr >> *('*'>>fctr | '/'>>fctr);
              fctr = real_p | '('>>expr>>')';
          }

          const rule_t& start() const { return expr; }
      };
};

int main()
{
    // @ArithCalcɊÂ\͊쐬
    ArithCalc parser;

    // Psǂݍ
    string line;
    while( cout<<"# ", getline(cin, line) )
    {
        // Ps\
        parse_info<string::const_iterator> info =
            parse( line.begin(), line.end(), parser, space_p );
        // ͑ŜparsełA"OK"ƕ\
        cout << (info.full ? "OK" : "fail") << endl;
    }   // ȉEOF͂܂ŌJԂ
    return 0;
}
