#include <iostream>
#include <iomanip>
#include <typeinfo>
#include <boost/type_traits.hpp>
using namespace std;
using namespace boost;

class Base { public: virtual ~Base(){} };
class Derived : public Base {};
class Mono {};

int main()
{
    // ^NXǂ̔
    cout << boolalpha;
    cout << "is_class<int>: "     << is_class<int>::value     << endl;
    cout << "is_class<istream>: " << is_class<istream>::value << endl;

    // |C^^*菜
    remove_pointer<char*>::type x;
    cout << "remove_pointer<char*>: " << typeid(x).name() << endl;

    // ^^֕ϊ\H
    cout << "is_convertible<int, double>: "
         <<  is_convertible<int, double>::value << endl;
    cout << "is_convertible<Derived, Base>: "
         <<  is_convertible<Derived, Base>::value << endl;
    cout << "is_convertible<float, void*>: "
         <<  is_convertible<float, void*>::value << endl;

    // ԓIɐU镑^H
    cout << "is_polymorphic<Base>: " << is_polymorphic<Base>::value << endl;
    cout << "is_polymorphic<Mono>: " << is_polymorphic<Mono>::value << endl;
    return 0;
}
