#include <iostream>
#include <string>
#include <vector>
#include <boost/algorithm/string.hpp>
using namespace std;
using namespace boost::algorithm;

int main()
{
    vector<string> v;

    // '-''+'̎ŋ؂
    split( v, "abc-def+ghi", is_any_of("-+") );
    cout << join( v, "<>" ) << endl;

    // ̋󔒂ŋ؂Ăꍇ (token_compress_off)
    split( v, "This  is  a  pen", is_space() );
    cout << join( v, "<>" ) << endl;

    // ̋󔒂ŋ؂Ăꍇ (token_compress_on)
    split( v, "This  is  a  pen", is_space(), token_compress_on );
    cout << join( v, "<>" ) << endl;
}
