#include <boost/asio.hpp>
#include <boost/bind.hpp>
using namespace std;
using namespace boost;
using namespace boost::asio;
using ip::tcp;

class AddServer
{
public:
    AddServer( io_service& io )
      : io(io), acc(io,tcp::endpoint(tcp::v4(), 10101))
      { start(); } // acceptJn

private:
    io_service&    io;
    tcp::iostream   s;
    tcp::acceptor acc;

    void start()
    {
        // acceptthis->handler()ĂяoĂ炤B
        acc.async_accept( *s.rdbuf(), bind(&AddServer::handler,this,_1) );
    }

    void handler( const boost::system::error_code& e )
    {
        if(e) return; // ڑG[牽Ȃ

        // ͂̕Ƃŉǂ܂BҁI
        int x, y;
        s >> x >> y;
        s << x+y << endl;
        s.close();

        start();  // ̃NCAg҂
    }
};

class MulServer
{
public:
    MulServer( io_service& io )
      : io(io), acc(io,tcp::endpoint(tcp::v4(), 10101))
      { start(); } // acceptJn

private:
    io_service&    io;
    tcp::iostream   s;
    tcp::acceptor acc;

    void start()
    {
        // acceptthis->handler()ĂяoĂ炤B
        acc.async_accept( *s.rdbuf(), bind(&MulServer::handler,this,_1) );
    }

    void handler( const boost::system::error_code& e )
    {
        if(e) return; // ڑG[牽Ȃ

        // ͂̕Ƃŉǂ܂BҁI
        int x, y;
        s >> x >> y;
        s << x*y << endl;
        s.close();

        start();  // ̃NCAg҂
    }
};

int main()
{
    io_service io;
    AddServer ads(io);
    MulServer mls(io);

    io.run();
}
