#include <iostream>
#include <algorithm>
#include <vector>
#include <list>
#include <set>
#include <string>
#include <boost/array.hpp>
using namespace std;
using namespace boost;

struct print
{
    template<typename T>
      void operator()( const T& t ) const
        { cout << t << ", "; }
};

template<class Cont>
  void print_all( const Cont& c )
  {
      // 擪疖܂ŁAprint()֐IuWFNgKp
      for_each( c.begin(), c.end(), print() ); cout<<endl;
  }

int main()
{
    vector<double> v;
    v.push_back( 1.2 ); v.push_back( 3.4 ); // vector
    list<int> l;
    l.push_back( -5 ); l.push_back( -6 );   // list
    set<char> s;
    s.insert( 'X' ); s.insert( 'Y' );       // set
    array<string,2> a
      = {"aaa","bbb"};                      // array

    print_all( v );
    print_all( l );
    print_all( s );
    print_all( a ); // print_all֐ŁI
    return 0;
}
