#include <iostream>
#include <algorithm>
#include <boost/iterator/iterator_facade.hpp>
using namespace std;
using namespace boost;

// 悭PAXg̒`ł
struct MyLinkedList
{
    MyLinkedList* next;
    int           data;

    MyLinkedList( MyLinkedList* n, int d ) : next(n), data(d) {}
};

// iterator_facadegMyLinkedListp̃Ce[^`
struct ml_iterator
  : public iterator_facade<ml_iterator, int, forward_traversal_tag>
{
    ml_iterator()                     : ptr(0)    {}
    ml_iterator( MyLinkedList* list ) : ptr(list) {}

    int& dereference() const { return ptr->data; }
    void increment()         { ptr = ptr->next; }
    bool equal( const ml_iterator& rhs ) const { return ptr==rhs.ptr; }

private:
    MyLinkedList* ptr;
};

// eXgp֐
void plus50( int& x ) { x += 50; }
void print( int x )   { cout << x << endl; }

int main()
{
    // 100->200->300->400->500->600->endB
    MyLinkedList f( NULL, 600 );
    MyLinkedList e(  &f , 500 );
    MyLinkedList d(  &e , 400 );
    MyLinkedList c(  &d , 300 );
    MyLinkedList b(  &c , 200 );
    MyLinkedList a(  &b , 100 );

    // Ce[^gĂ݂B
    ml_iterator it1( &a ); // &awCe[^
    ml_iterator it2;       // wCe[^
    for_each( it1, it2, plus50 );
    for_each( it1, it2, print );
    return 0;
}
