#include <iostream>
#include <utility>
#include <boost/variant.hpp>
using namespace std;
using namespace boost;

typedef make_recursive_variant<
    int, pair<recursive_variant_,recursive_variant_>
>::type tree;

// intԂvisitor֐
struct add_all : static_visitor<int>
{
    // variant̒gint̏ꍇ
    int operator()( int i ) const { return i; }
    // variant̒gpair<tree,tree>̏ꍇ
    int operator()( const pair<tree,tree>& n ) const
    {
        return apply_visitor( *this, n.first )
             + apply_visitor( *this, n.second );
    }
};

int main()
{
    tree t = make_pair( 2, make_pair( make_pair(6,5), 3 ) );
    cout << apply_visitor( add_all(), t ) << endl;
    return 0;
}
