#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <boost/bind.hpp>
using namespace std;
using namespace boost;

int main()
{
    vector<string> v;
    v.push_back("abcde");
    v.push_back("fghijklmn");
    v.push_back("");
    v.push_back("opqr");
    v.push_back("stuvwxyz");

    // 󕶎菜
    //   bind(&string::empty, _1)( s ) == s.empty()
    vector<string>::iterator end =
        remove_if( v.begin(), v.end(), bind(&string::empty, _1) );

    // éA[2]2oϊ
    //   bind(&string::substr, _1, 2, 2)( s ) == s.substr(2,2)
    transform(
        v.begin(), end, v.begin(), bind(&string::substr, _1, 2, 2) );

    cout << v[0] << ' ' << v[1] << ' ' << v[2] << ' ' << v[3] << endl;
    return 0;
}
