#include <iostream>
#include <string>
#include <boost/lexical_cast.hpp>
#include <boost/fusion/sequence.hpp>
#include <boost/fusion/algorithm.hpp>
using namespace std;
using namespace boost;
using namespace boost::fusion;

// ɒ
struct ToString
{
	template<typename T>
	string operator()( const T& t ) const
	{
		return lexical_cast<string>(t);
	}

    template<typename T>
    struct result
    {
        typedef string type;
    };
};

int main()
{
    // "transform" ASY
    boost::fusion::vector<int,string,float> t(123, "ɂ", 4.56);
    boost::fusion::vector<string,string,string> s
      = transform( t, ToString() );

    cout << at_c<0>(s) << at_c<1>(s) << at_c<2>(s) << endl;
}
