#ifndef NAMED_OBJECT_H
#define NAMED_OBJECT_H

#include <cstdlib>
#include <stdexcept>
using namespace std;

class named_object
{
    bool strcmp_i( const char* a, const char* b ) const
    {
        while( *a && *b && tolower(*a)==tolower(*b) ) ++a, ++b;
        return *a==*b;
    }
    const char* const name;
public:
    named_object( const char* name ) : name(name)
      { if(!name) throw std::invalid_argument("Null Not Allowed"); }
    const char* get_name() const { return name; }
    bool name_is( const char* str ) const
      { return strcmp_i(name, str); }
};

#endif // include_guard
